/*
   TCDirTree v 1.02 (with threads)

   Created by: Alexander Melnikov
   e-mail: alm@tolmachevo.ru
   Modified by:
   Last updated:


   Copyright: 1998 ALM(COFF).

   Modifications Copyright:

   Permission granted to copy, modify, and otherwise use the modifications
   to this code in whatever manner you see fit, with no warranty expressed or
   implied.  Please retain this notice; this is the only restriction.If you
   make any changes to the original code and/or modifications put forth by
   ALM(COFF), plase credit yourself so that ALM(COFF) is not asked to
   maintain versions of this modified code that were not developed by
   ALM(COFF).

   ALM(COFF) GIVES NO WARRANTY, EXPRESSED OR IMPLIED, FOR THE SOFTWARE
   AND/OR DOCUMENTATION PROVIDED, INCLUDING, WITHOUT LIMITATION, WARRANTY
   OF MERCHANTABILITY AND WARRANTY OF FITNESS FOR A PARTICULAR PURPOSE.

   ********** Important notice ***************
   You Cannot,get **any** monies for this code
   without the prior consent of the author.
   You Cannot, Take any of the ideas presented
   here and produce a product for distribution
   without the express consent of the author.
   *******************************************

*/
#include <vcl.h>
#include <controls.hpp>
#include <ctype.h>
#include <dir.h>
#include <stdlib.h>
#include <assert.h>
#pragma hdrstop
#include "images.h"
#include "DirTree.h"
#pragma resource "images.res"
#pragma package(smart_init)

static inline void ValidCtrCheck(TCDirTree *)
{ new TCDirTree((TComponent *)NULL);  }

namespace Dirtree
{ void __fastcall PACKAGE Register()
        {

                 TComponentClass classes[2] = {__classid(TCDirTree),__classid(TCThDirTree)};
                 RegisterComponents("COFF", classes, 1);
                 RegisterComponentEditor(classes[0], __classid(TCDirTreeEditor));
        }
}

namespace {
    class FileFind {
        private:
            WIN32_FIND_DATA find_info;
            HANDLE handle;
            bool result;
            bool IsOk()                      { return result; }
            int  GetError()                  { return GetLastError(); }
        public:
            FileFind(const AnsiString &Path)
            {
                result = true;
                handle = FindFirstFile (Path.c_str(), &find_info);
                if(handle ==  INVALID_HANDLE_VALUE) result = false;
            }
            ~FileFind()                      { FindClose(handle); }
            __property bool Ok             = { read = IsOk };
            __property int Error           = { read = GetError };

            WIN32_FIND_DATA &GetFindData()   { return find_info; }
            operator bool()                  { return Ok; }
            bool Next()
            {
                result = FindNextFile (handle, & find_info);
                return result;
            }
    };
};

inline bool HasDirectories(String Path)
{
  if(Path == "") return false;
  FileFind Find(Path+"*.*");
  for (int i=0;
        i<3,Find.Ok;
        i++,Find.Next())
    {
         WIN32_FIND_DATA &SFRec = Find.GetFindData();
           if((SFRec.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) &&
               SFRec.cFileName[0] != '.')
                 return true;
    }
  return false;
}

// definitions of static data members
// ----------------------------------
void *TCDirTree::APointer = &TCDirTree::APointer;
void *TCDirTree::tmpPointer = &TCDirTree::tmpPointer;

//-[Class TReLevelTh]--------------------------------------------------------
int __fastcall Compare(void* Item1,void* Item2)
{
  TNoLi *i1 = reinterpret_cast<TNoLi *>(Item1);
  TNoLi *i2 = reinterpret_cast<TNoLi *>(Item2);
  return i2->Name.AnsiCompareIC(i1->Name);
}

void __fastcall TReLevelTh::Execute()
{
//while(1)
//{

use = false;
Screen -> Cursor = crAppStart;
for (FileFind Find(FPath+"*");
     Find.Ok;  //,Terminated == false
     Find.Next())
    {
        WIN32_FIND_DATA &SFRec = Find.GetFindData();
        // only store directories, ignoring "." and ".."
        if((SFRec.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) && SFRec.cFileName[0] != '.')
          {
             TNoLi* li = new TNoLi;
            if(li != NULL)
            {
              li->Name = String(SFRec.cFileName);//ForceCase(SFRec.cFileName);
              li->HasDirectories = HasDirectories(FPath+li->Name+"\\");

            }
            FNodeList->Add(reinterpret_cast<void *>(li));
          }
    }
       FNodeList->Pack();
       FNodeList->Sort(Compare);
    use = true;
    //**********************************************

      Priority = tpHighest;
       Synchronize(AddNode);
      Priority = tpNormal;
       Synchronize(Done);
    use = false;
    Screen -> Cursor = crDefault;
    FNodeList->Clear();

    //Suspend();
 //}
 FreeOnTerminate = true;
}
//---------------------------------------------------------------------------
void __fastcall TReLevelTh::AddNode()
{
    if(FNodeList->Count == 0) return; // if TList is empty.....
    int i = 0;
    TNoLi* li = reinterpret_cast<TNoLi *>(FNodeList->Items[i++]);
    TTreeNode *FirstNode = FRootNode->getFirstChild();
    if(FirstNode != NULL && li->Name != "" && FirstNode->Data == TCDirTree::tmpPointer)
    {
      FirstNode->Text = li->Name;
      FirstNode->Data = NULL;
      FirstNode->ImageIndex = IDB_CLOSDIR - IDB_BASE - 1;
      FirstNode->SelectedIndex = IDB_OPENDIR - IDB_BASE - 1 ;
      if(li->HasDirectories)(FItems->AddChild(FirstNode,""))->Data = TCDirTree::tmpPointer;
    }
    else
    {
      ShowMessage("Error *tmp " + IntToStr(FirstNode != NULL)+" "+IntToStr(li->Name != "")+" "+IntToStr(FirstNode->Data == TCDirTree::tmpPointer));
      return;
    }
    //
    for(;i<FNodeList->Count;i++)
    {
     FCurIndex = i;
     li = reinterpret_cast<TNoLi *>(FNodeList->Items[FCurIndex]);
     if(li == NULL)ShowMessage("Error ****list");
     FNode = FItems->AddFirst(FirstNode, li->Name);
     if(FNode!=NULL)
     {
        FNode->ImageIndex = IDB_CLOSDIR - IDB_BASE - 1 ;
        FNode->SelectedIndex = IDB_OPENDIR - IDB_BASE - 1 ;
     if(li->HasDirectories)
       (FItems->AddChild(FNode,""))->Data = TCDirTree::tmpPointer;
     }
    }

}
//---------------------------------------------------------------------------
void __fastcall TReLevelTh::Done()
{
     FRootNode->Data = TCDirTree::APointer;

}
//---------------------------------------------------------------------------
__fastcall TReLevelTh::TReLevelTh(TTreeNodes *Items,String Path,TTreeNode *RootNode)
                      :TThread(true)
{
   use = false;
   if(Items == NULL) throw;
   FItems = Items;

   FNodeList = new TList();
   FPath = Path;
   FRootNode = RootNode;
   if(FPath != "" && FRootNode != NULL) Resume();

}
//---------------------------------------------------------------------------
/*
void __fastcall TReLevelTh::DoChangeInt(AnsiString &Path,TTreeNode *RootNode)
{
   if(use) return;
   //if(!Terminated) Terminate();
   FPath = Path;
   FRootNode = RootNode;
   if(FPath != "" && FRootNode != NULL) Resume();
}
*/
//-[end Class TReLevelTh]----------------------------------------------------

// inline helpers
// --------------
inline String FullPath(TTreeNode *Node)
{
 if(Node == NULL) return ".";
 String path = "";
 path.Insert(Node->Text,0);
 TTreeNode *tmpNode=Node;
 while(tmpNode->Level >0)
 {
  tmpNode = tmpNode->Parent;
  if(tmpNode!=NULL)
   path.Insert(tmpNode->Text+"\\",0);
 }
 return path + "\\";
}

inline bool SameLetter(char a, char b)
{
    return toupper(a) == toupper(b);
}

inline int GetPos(const AnsiString& s, const AnsiString& p)
{
    return s.AnsiPos(p);
}

inline TTreeNode* SortOrder(TTreeNode *RootNode,AnsiString Name)
{
  TTreeNode* Child = RootNode->getFirstChild();
  while (Child != NULL && Child->Text.AnsiCompareIC(Name) < 0)
                   Child = RootNode->GetNextChild(Child);
  return Child;
}

//---------------------------------------------------------------------------

__fastcall TCDirTree::TCDirTree(TComponent* Owner)
    : TCustomTreeView(Owner)
{
    ImagesList = new TImageList (this);
    ImagesList -> AllocBy = 6;
    ImagesList -> ShareImages = true;
    Graphics::TBitmap *bmp = new Graphics::TBitmap();
   try{
       bmp->LoadFromResourceID((int)Sysinit::HInstance, IDB_TMP);
       ImagesList->Add(bmp,bmp);
       bmp->LoadFromResourceID((int)Sysinit::HInstance,IDB_OPENDIR);
       ImagesList->Add(bmp,bmp);
       bmp->LoadFromResourceID((int)Sysinit::HInstance,IDB_CLOSDIR);
       ImagesList->Add(bmp,bmp);
       bmp->LoadFromResourceID((int)Sysinit::HInstance,IDB_FLOPDRV);
       ImagesList->Add(bmp,bmp);
       bmp->LoadFromResourceID((int)Sysinit::HInstance,IDB_HARDDRV);
       ImagesList->Add(bmp,bmp);
       bmp->LoadFromResourceID((int)Sysinit::HInstance,IDB_CDRMDRV);
       ImagesList->Add(bmp,bmp);
       bmp->LoadFromResourceID((int)Sysinit::HInstance,IDB_NETWDRV);
       ImagesList->Add(bmp,bmp);
    bmp->FreeImage();
     }
     catch(...){ MessageBeep(MB_ICONEXCLAMATION);}
    delete bmp;


    Images = ImagesList;

   FOnDirectoryChange = NULL;
   ShowButtons = true;
   RightClickSelect = true;
   HideSelection = false;
   SortType = stText;
   AssignCaseProc();
}
//---------------------------------------------------------------------------
__fastcall TCDirTree::~TCDirTree()
{
  for (int i = 0; i < LDrives->Count; i++)
   delete (PDriveNode) LDrives->Items[i];

   delete LDrives;
   delete ImagesList;
}
//---------------------------------------------------------------------------
/*
void __fastcall TCDirTree::WndProc (Messages::TMessage & Message)
{

  switch (Message.Msg)
 {
  case WM_RBUTTONUP:
  {
       int xPos = LOWORD(Message.LParam);
       int yPos = HIWORD(Message.LParam);

      TPopupMenu *pm = new TPopupMenu(this);
      TMenuItem *NewItem = new TMenuItem(this); // create the separator
      NewItem->Caption = "-";
      pm->Items->Add(NewItem); //
          NewItem = new TMenuItem(this);
          if(Selected->Data == NULL)
            NewItem->Caption = "NULL ptr "+ Selected->Text;
          else
          if(Selected->Data == APointer)
            NewItem->Caption = "APointer ptr "+ Selected->Text;
          else
          if(Selected->Data == tmpPointer)
            NewItem->Caption = "tmpPointer ptr "+ Selected->Text;
      pm->Items->Add(NewItem);
      pm->Popup(ClientOrigin.x + xPos,ClientOrigin.y + yPos);
      delete pm;
  }
  break;
  default:
       TCustomTreeView::WndProc(Message);
 }
}
  */
//----------------------------------------------------------------------------
inline int __fastcall TCDirTree::DriveToInt(char d)
{
    // this assumes that A..Z are contiguous and packed
    return toupper(d) - 'A';
}
//---------------------------------------------------------------------------
inline char __fastcall TCDirTree::IntToDrive(int i)
{
    // this assumes that A..Z are contiguous and packed
    return static_cast<char>(i + 'A');
}
//---------------------------------------------------------------------------
void __fastcall TCDirTree::AssignCaseProc()
{
    switch (TextCase) {
        case tcLowerCase:
            FCaseFunction = AnsiLowerCaseFileName;
            break;

        case tcUpperCase:
            FCaseFunction = AnsiUpperCaseFileName;
            break;
        default:
            FCaseFunction = NULL;
            break;
    }

}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
bool __fastcall TCDirTree::BuildOneLevel(TTreeNode *RootNode)
{
    if(ComponentState.Contains(csDesigning)) return false;
    bool bHasdir = false;
    TTreeNode *NearNode;
      for (FileFind Find(FullPath(RootNode)+"*.*");
           Find.Ok;
           Find.Next())
    {
        WIN32_FIND_DATA &SFRec = Find.GetFindData();
        Application->ProcessMessages();
        // only store directories, ignoring "." and ".."
        if((SFRec.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) && SFRec.cFileName[0] != '.')
          {
            AnsiString Name = ForceCase(SFRec.cFileName);
            bHasdir = true;
              NearNode = RootNode->getFirstChild();
              if(NearNode!=NULL && NearNode->Data == tmpPointer)
              {
                  NearNode->Data = NULL;
                  NearNode->Text = Name;
              }
              else
              {
                //insert in sort order
                NearNode = SortOrder(RootNode,Name);
                if (NearNode!=NULL)
                     NearNode =Items->Insert(NearNode, Name);
                else
                {
                  NearNode = RootNode->GetLastChild();
                  NearNode = Items->Add(NearNode, Name);
                }
              }
                if(HasDirectories(FullPath(NearNode)))
                    (Items->AddChild(NearNode,"?"))->Data = tmpPointer;

                           if(NearNode!=NULL)
                           {
                              NearNode->ImageIndex = IDB_CLOSDIR - IDB_BASE - 1;
                                NearNode->SelectedIndex = IDB_OPENDIR - IDB_BASE - 1;
                           }
        }

    }

   return bHasdir;
}
//---------------------------------------------------------------------------
void __fastcall TCDirTree::BuildAllDrives()
{
    if (FDrive == 0)
    {  AnsiString path = ForceCase(CurDir());
        if (path.Length() != 0)
        {   FDrive = path[1];
            FDirectory = path;
        }
    }

  DWORD DriveBits = GetLogicalDrives();
  DWORD mask = 1 ;
  char cdrv[]="!:\\";

  LDrives = new TList;

  Items->BeginUpdate();
  Items->Clear();
  for(int Drive = 0; Drive < 26 ; Drive ++)
  {
    Application->ProcessMessages();
    if(mask & DriveBits)
    {
      TDriveNode *sNode = new TDriveNode;
      sNode->Drive = Drive;
      cdrv[0] = IntToDrive(sNode->Drive);
      sNode->type = GetDriveType(cdrv);
      switch (sNode->type)
      {
        case 0: sNode->BitMap = IDB_HARDDRV - IDB_BASE - 1;// The drive type cannot be determined.
         break;
        case 1: sNode->BitMap = IDB_HARDDRV - IDB_BASE - 1;//The root directory does not exist.
         break;
        case DRIVE_REMOVABLE: sNode->BitMap = IDB_FLOPDRV - IDB_BASE - 1;//The drive can be removed from the drive.
         break;
        case DRIVE_FIXED: sNode->BitMap = IDB_HARDDRV - IDB_BASE - 1; //The disk cannot be removed from the drive.
         break;
        case DRIVE_REMOTE: sNode->BitMap = IDB_NETWDRV - IDB_BASE - 1;//The drive is a remote (network) drive.
         break;
        case DRIVE_CDROM: sNode->BitMap = IDB_CDRMDRV - IDB_BASE - 1;//The drive is a CD-ROM drive.
         break;
        case DRIVE_RAMDISK: sNode->BitMap = IDB_HARDDRV - IDB_BASE -1;//The drive is a RAM disk.
         break;
        default:
          assert(false);
      }
      sNode->Node = Items->AddChild(0,String(UpCase(IntToDrive(sNode->Drive))) + ":"); // was ":\\"
      BuildDrive(sNode);
      LDrives->Add(sNode);

    }
    mask = mask << 1; //shift mask bit
  }
  LDrives->Pack();
  Selected=Items->Item[3];
  WalkTree(FDirectory);
  ChangePath(FDirectory);

  Items->EndUpdate();
}
//---------------------------------------------------------------------------
void __fastcall TCDirTree::BuildDrive(DriveNode *sNode)
{
    sNode->Node->ImageIndex =  sNode->BitMap;
    sNode->Node->SelectedIndex = sNode->BitMap;
    sNode->Node->Data = NULL;
    (Items->AddChild(sNode->Node,""))->Data = TCDirTree::tmpPointer;
}
//---------------------------------------------------------------------------

void __fastcall TCDirTree::Expand(TTreeNode* Node)
{
    Screen -> Cursor = crHourGlass;
    if(Node->Data==NULL)
    {
    Items->BeginUpdate();
        if(!BuildOneLevel(Node))
                  Node->DeleteChildren();
        else
                  TCustomTreeView::Expand(Node);
    Node->Data = APointer;
    Items->EndUpdate();
    }
    Screen -> Cursor = crDefault;
}
//---------------------------------------------------------------------------

void __fastcall TCDirTree::ChangePath(AnsiString &Path)
{
	if (Path.IsEmpty ())
    	return;

    if (FOnDirectoryChange)
	    FOnDirectoryChange (this,Path);

}
//---------------------------------------------------------------------------
void __fastcall TCDirTree::Click()
{
   Directory = FullPath(Selected);
   TCustomTreeView::Click();
}
//---------------------------------------------------------------------------
void __fastcall TCDirTree::CreateWnd()
{
    TCustomTreeView::CreateWnd();
        if (!Loading)
           BuildAllDrives();

}
//---------------------------------------------------------------------------
void __fastcall TCDirTree::Loaded()
{
    Loading = true;
    TCustomTreeView::Loaded();
    AssignCaseProc();
    Loading = false;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TCDirTree::ForceCase(const AnsiString &s)
{
    return FCaseFunction ? (*FCaseFunction)(s) : s;
}
//---------------------------------------------------------------------------
void __fastcall TCDirTree::SetDirectory(const TFileName NewDir)
{
    if (NewDir.Length() > 0) {
        TFileName Path = ForceCase(ExpandFileName(NewDir));
        int n = Path.Length();

        if (n > 3 && Path.IsPathDelimiter(n))
            Path.SetLength(n - 1);

        if (Path != FDirectory)
        {

            FDirectory = Path;
            UINT olderr = SetErrorMode(SEM_FAILCRITICALERRORS);
            chdir(FDirectory.c_str());
            SetErrorMode(olderr);

            if (!SameLetter(Path[1], Drive))
               Drive = Path[1];

             if(FDirectory.Length() != 3)
                      WalkTree(FDirectory);
               ChangePath(FDirectory);
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TCDirTree::SetDrive(char NewDrive)
{
    // the original sample did not throw an exception here.
    // should we do so now?
    NewDrive = static_cast<char>(toupper(NewDrive));
    if ((NewDrive >= 'A' && NewDrive <= 'Z')) {
        if (!SameLetter(NewDrive, FDrive)) {
            TDriveNode* sNode = GetLDriveItem(DriveToInt(FDrive));
            if(sNode != NULL)
            {
             if(sNode->type == DRIVE_CDROM     ||
                sNode->type == DRIVE_REMOTE    ||
                sNode->type == DRIVE_REMOVABLE ||
                sNode->type == DRIVE_RAMDISK   ||
                sNode->type == 0               ||
                sNode->type == 1)
             {
               sNode->Node->Collapse(true);
               sNode->Node->DeleteChildren();
               BuildDrive(sNode);
             }
             //-----------------------------------------
            FDrive = NewDrive;

            UINT olderr = SetErrorMode(SEM_FAILCRITICALERRORS);
            setdisk(DriveToInt(FDrive));
            SetErrorMode(olderr);


            FDirectory = ForceCase(CurDir());
            }
        }
    }
}

//---------------------------------------------------------------------------
void __fastcall TCDirTree::SetTextCase(TTextCase NewCase)
{
    if (NewCase != FTextCase) {
        FTextCase = NewCase;
        AssignCaseProc();

        if (NewCase == tcAsIs) {
            AnsiString CurrentPath = CurDir();
            FDrive = CurrentPath[1];
            FDirectory = CurrentPath;
        }

        if (!ComponentState.Contains(csLoading))
            BuildAllDrives();
    }
}
//---------------------------------------------------------------------------
AnsiString TCDirTree::CurDir()
{
    const initbuf = 256;
    size_t buflen = initbuf;
    char *buf = reinterpret_cast<char *>(malloc(buflen));

    if (buf) {
        buflen = GetCurrentDirectory(buflen, buf);
        if (buflen > initbuf) {
            char *p = reinterpret_cast<char *>(realloc(buf, buflen));
            if (p) {
                buf = p;
                buflen = GetCurrentDirectory(buflen, buf);
            }
        }
    }

    try {
        AnsiString Result((buflen && buf) ? buf : "");
        free(buf);
        return Result;
    } catch (...) {
        free(buf);
        throw;
    }
}
//---------------------------------------------------------------------------
TTreeNode* __fastcall TCDirTree::GetChildNamed(const AnsiString& Name,
        TTreeNode* Item)
{
    String AText, AName;
    TTreeNode* Node = Item->getFirstChild();
    AName = AnsiUpperCase(Name);

      if(Node!=NULL)
        AText = AnsiUpperCase(Node->Text);

       if(AName == AText)
         return Node;

           while (Node !=NULL && AText != AName)
            {
              Node = Item->GetNextChild(Node);
                if (Node != NULL)
                  AText = AnsiUpperCase(Node->Text);
            }
    return Node;
}

//---------------------------------------------------------------------------
TDriveNode* __fastcall TCDirTree::GetLDriveItem(int Drive)
{
  TDriveNode *sNode;
  for(int j=0;j<LDrives->Count;j++)
  {
   sNode = (PDriveNode)LDrives->Items[j];
    if(sNode == NULL)
       throw;
     if(sNode->Drive == Drive)
       return sNode;
  }
  return NULL;
}
//---------------------------------------------------------------------------
void __fastcall TCDirTree::WalkTree(const AnsiString& Dest)
{
    AnsiString Path = ForceCase(Dest);

    if(Path.SubString(Path.Length()-1,1)!="\\")
       Path+="\\";
    TDriveNode *sNode = GetLDriveItem(DriveToInt(Path[1]));
    if(sNode != NULL)
    {
     TTreeNode *Item = sNode->Node;
     // remove drive component of Path
     int Colon = Path.Pos(":");
        if (Colon > 0)
        {
          int Offset = (Path[Colon + 1] == '\\') ? 2 : 1;
          Path = Path.SubString(Colon + Offset, Path.Length());
        }
    // do the walk
    for (int SlashPos = GetPos(Path, "\\");
             Path.Length() > 0;
             SlashPos = GetPos(Path, "\\"))
    {
        AnsiString Dir = Path;

        if (SlashPos > 0)
        {   // splice out the first directory
            Dir  = Path.SubString(1, SlashPos - 1);
            Path = Path.SubString(SlashPos + 1, Path.Length());
        }
        else
        {  Dir = Path; Path = "";
        }
        Item->Expanded = true;
        Item = GetChildNamed(Dir, Item);
    }
    if(Item!=NULL)
        {
          SetFocus();
          Selected = Item;
        }
    }
}

//---------------------------------------------------------------------------
void __fastcall TCDirTree::GoParent()
{
   if(Selected->Level > 0) Selected = Selected->Parent;
}
//---------------------------------------------------------------------------
void __fastcall TCDirTree::Change(TTreeNode *Node)
{
   Click();
   if(Node != NULL) Selected = Node;
   TCustomTreeView::Change(Node);
}
//---------------------------------------------------------------------------
//***************************************************************************
void __fastcall TCDirTreeEditor::Edit(void)

{

  TForm *fwin = new TForm(Application);
  fwin->Height = (Screen->Height /4)*3;
  fwin->Width  = Screen->Width /3;
  fwin->Left = 0;
  fwin->Top = 0;
  TCDirTree *td = new TCDirTree(fwin);
  td->Parent = fwin;
  td->Align = alClient;
  td->Visible = true;
  fwin->ShowModal();
  delete td;
  delete fwin;

/*
  TFontDialog *pFontDlg = new TFontDialog(NULL);
  pFontDlg->Execute();
  // note the use of the Component property
  // to access the instance of TMyComponent
  ((TCDirTree *)Component)->Font = pFontDlg->Font;
  delete pFontDlg;
*/
}

void __fastcall TCThDirTree::Expand(TTreeNode *Node)
{
   if(Node->Data==NULL)
    {
        //FReTh->DoChangeInt(FullPath(Node),Node);
        new TReLevelTh(Items,FullPath(Node),Node);
        TCustomTreeView::Expand(Node);
    }
}

